import { ViewContainerRef } from '@angular/core';
import { Subscription } from 'rxjs';
import { TruDataChange } from '../../classes/tru-data-change';
import { TruDesktopViewConfig } from '../../components/desktop/classes/tru-desktop-view-config';
import { TruDesktopManager } from '../../components/desktop/services/tru-desktop-manager';
import { TruDesktopViewEventNotifier } from '../../components/desktop/services/tru-desktop-view-event-notifier';
import { TruWindowEventHandler } from '../../components/desktop/services/tru-window-event-handler';
import { TruAppEnvironment } from '../../services/tru-app-environment';
import { TruDataContext } from '../../services/tru-data-context';
import { TruTextManager } from '../../services/tru-text-manager';
import { TruUtil } from '../../services/tru-util';
import { TruComponentLookup } from '../../services/tru-component-lookup';
import * as i0 from "@angular/core";
export declare class TruDetailViewBase {
    protected dataContext: TruDataContext;
    protected componentLookup: TruComponentLookup;
    protected appEnvironment: TruAppEnvironment;
    protected textManager: TruTextManager;
    protected desktopManager: TruDesktopManager;
    protected windowEventHandler: TruWindowEventHandler;
    protected desktopViewEventNotifier: TruDesktopViewEventNotifier;
    protected util: TruUtil;
    customToolbarContainer: ViewContainerRef;
    view: TruDesktopViewConfig;
    private childUpdateFn;
    protected tableName: string;
    protected tablePluralName: string;
    protected tablePluralLabel: string;
    protected parentTableName: string;
    protected parentTablePluralName: string;
    protected parentTablePluralLabel: string;
    protected customToolbarComponents: any;
    entities: Array<any>;
    entity: any;
    entityType: any;
    recordLocation: string | null;
    disableNavigationToPreviousEntity: boolean;
    disableNavigationToNextEntity: boolean;
    navigationIndex: number;
    recordsBeforeRevert: number;
    subs: Array<Subscription>;
    constructor(dataContext: TruDataContext, componentLookup: TruComponentLookup, appEnvironment: TruAppEnvironment, textManager: TruTextManager, desktopManager: TruDesktopManager, windowEventHandler: TruWindowEventHandler, desktopViewEventNotifier: TruDesktopViewEventNotifier, util: TruUtil);
    private calculateNextIndex;
    protected renderCustomToolbarComponents: () => void;
    onAddEntity: (newEntity: any) => void;
    onCloneEntity: () => void;
    onDeleteEntity: () => void;
    onFirstEntity: () => void;
    onPreviousEntity: () => void;
    onNextEntity: () => void;
    onLastEntity: () => void;
    navigateTo: (index: number) => void;
    registerChildUpdateFn: (func: (dataChange: TruDataChange | null) => void) => void;
    subscribe(): void;
    setNavigationIndex(index: number): void;
    setEntityDisplayValues(tableName: string): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruDetailViewBase, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TruDetailViewBase, "tru-detail-view-base", never, { "view": { "alias": "view"; "required": false; }; }, {}, never, never, true, never>;
}
