import { TruDesktopManager } from '../../components/desktop/services/tru-desktop-manager';
import { TruWindowEventHandler } from '../../components/desktop/services/tru-window-event-handler';
import { TruDesktopViewConfig } from '../../components/desktop/classes/tru-desktop-view-config';
import { TruDesktopTitle } from '../../components/desktop/classes/tru-desktop-title';
import { TruEntityBase } from '../../base-classes/tru-entity-base';
import * as i0 from "@angular/core";
export declare class TruSearchViewBase {
    protected desktopManager: TruDesktopManager;
    protected windowEventHandler: TruWindowEventHandler;
    protected view: TruDesktopViewConfig;
    protected tableName: string;
    protected tablePluralName: string;
    protected tablePluralLabel: string;
    protected pkeyName: string;
    protected windowTitle: TruDesktopTitle | undefined;
    protected windowConfig: any;
    protected unsubscribes: never[];
    protected expands: never[];
    protected contextFilters: any;
    protected isSearching: boolean;
    protected entities: never[];
    protected hasDetailView: boolean;
    searchPanelConfig: {
        side: string;
        active: boolean;
        open: boolean;
        modKeyLabel: string;
        size: number;
        pinned: boolean;
    };
    constructor(desktopManager: TruDesktopManager, windowEventHandler: TruWindowEventHandler);
    setWindowTitle(title?: string | undefined): void;
    releaseWindowTitle(): void;
    onPkeyCellDoubleClicked: (gridConfig: any) => void;
    onAddCustomView: (componentName: string, entities: Array<TruEntityBase>) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruSearchViewBase, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TruSearchViewBase, "tru-search-view-base", never, { "view": { "alias": "view"; "required": false; }; }, {}, never, never, true, never>;
}
