import { Subject } from "rxjs";
import { TruEntityBase } from "../base-classes/tru-entity-base";
import { TruAppEnvironment } from "../services/tru-app-environment";
import { TruDataContext } from "../services/tru-data-context";
import { TruModelPropertyLookup } from "../services/tru-model-property-lookup";
import { TruModelTypeLookup } from "../services/tru-model-type-lookup";
import { TruDataChange } from "./tru-data-change";
export declare class TruDataChangeParser {
    private appEnvionment;
    private dataContext;
    private entity;
    private tableName;
    private addEntity;
    private getLatestResults;
    private getLatestQuery;
    private contextFilters;
    private expandPaths;
    private isLoaded;
    private types;
    private propertyTypes;
    private globalDataContext;
    private waitingEntities;
    private dataChanged$;
    onDataChanged(): Subject<TruDataChange>;
    dataChanged(change: TruDataChange): void;
    constructor(connection: any, appEnviroment: TruAppEnvironment, dataContext: TruDataContext, globalDataContext: TruDataContext | null, entity: typeof TruEntityBase, tableName: string, addEntity: any, getLatestResults: any, getLatestQuery: any, contextFilters: [], expandPaths: Array<string>, isLoaded: () => boolean, modelTypeLookup: TruModelTypeLookup, modelPropertyLookup: TruModelPropertyLookup);
    private findEntityInCache;
    private findEntityInGlobalCache;
    private checkIfDateTime;
    private hasPropertyAlreadyBeenModified;
    private applyPropertyChanges;
    private setWaitingEntitiesToUnchanged;
    private entityFoundByQuery;
    private getEntityFromServer;
    private getEntityFromResults;
    private isSaving;
    private update;
}
