import { TruPredicate } from "./tru-predicate";
export declare class TruQueryPredicateManager {
    _predicate: TruPredicate | null;
    _propertyQueryPath: Array<string> | null;
    _predicateName: string;
    _predicateMap: any;
    constructor(propertyQueryPath: Array<string>, predicateName: string, predicateMap: any);
    private setPredicate;
    /**
     * Returns the query predicate.
     */
    get: () => TruPredicate | null;
    /**
   * Clears the query predicate.
   */
    clear: () => void;
    /**
   * Returns a new query predicate.
   *
   * @param {string} field - Name of the storage field relative to the intent property.
   * @param {string} operator - Name of the predicate operator.
   * @param {*} value - Literal value.
   */
    create: (field: string, operator: string, value: any, overQuoted?: boolean) => any;
    set: (fieldOrPredicate: string | TruPredicate, operator?: string, value?: any, overQuoted?: boolean) => void;
}
