import { ElementRef, TemplateRef } from '@angular/core';
import { TruSearchViewEventHandler } from '../../base-views/search/services/tru-search-view-event-handler';
import { TruDataContext } from '../../services/tru-data-context';
import { TruModelTypeLookup } from '../../services/tru-model-type-lookup';
import { TruSearchResultViewManager } from '../../services/tru-search-result-view-manager';
import { ITruToolbarDropdownOption } from '../toolbar/classes/tru-toolbar-dropdown-option';
import { ITruCardColumnConfig } from './classes/tru-card-column-config';
import { TruCard } from './tru-card';
import * as i0 from "@angular/core";
export declare class TruCardColumn {
    private dataContext;
    private modelTypeLookup;
    private searchViewEventHandler;
    private searchResultViewManager;
    config: ITruCardColumnConfig;
    name: any;
    portal: ElementRef;
    private parentTablePluralLabel;
    private childTableName;
    private parentQuery;
    private lockProperty;
    private unassignedLocked;
    private unassignedDraggable;
    private unassignedDroppable;
    private inactiveVisible;
    private inactiveDraggable;
    private inactiveDroppable;
    private columnSort;
    private cardSort;
    private relatedParentName;
    private relatedChildName;
    private insertBefore;
    private uniqueId;
    private subs;
    parentTableName: string;
    childTablePluralLabel: string;
    busyMessage: string;
    isBusy: boolean;
    columns: any;
    cards: any;
    lockedColumns: any;
    columnFilterChoices: Array<ITruToolbarDropdownOption> | null;
    columnFilterRefs: Array<number>;
    cardFilterStr: string | null | undefined;
    selectedCards: Array<TruCard>;
    color: string | null;
    unassignedColor: string | null;
    key: string;
    unassignedVisible: boolean;
    unassignedName: string | null;
    userHasParentTableRole: boolean;
    viewMenuItems: any;
    selectedViewMenuItem: any | null;
    parentToolbarTemplate: TemplateRef<any> | null;
    columnFilterTooltip: string;
    cardFilterTooltip: string;
    columnDropdownFilterTooltip: string;
    constructor(dataContext: TruDataContext, modelTypeLookup: TruModelTypeLookup, searchViewEventHandler: TruSearchViewEventHandler, searchResultViewManager: TruSearchResultViewManager);
    private parentTableModel;
    private createDataForEntity;
    private hasUndefinedChildren;
    private hasEmptyChildren;
    private hasInactiveChildren;
    private hasAddedUnsavedChildren;
    private clear;
    private getValueFromSortPath;
    private updateItemsSource;
    private subscribeTo;
    private onSearch;
    filterColumns: (selectedOptions: Array<ITruToolbarDropdownOption> | null) => void;
    filterCards: (value: string | null | undefined) => void;
    updateSelection: (card: TruCard) => void;
    dragStart: (e: any, card: TruCard) => boolean;
    dragOver: (e: any, card: TruCard) => void;
    dragEnd: (e: any) => void;
    drop: (e: any, card: TruCard) => Promise<boolean>;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    removeSelection: (card: TruCard) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruCardColumn, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TruCardColumn, "tru-card-column", never, { "config": { "alias": "config"; "required": false; }; "name": { "alias": "name"; "required": false; }; }, {}, never, never, true, never>;
}
