import { TruViewBase } from '../../base-views/tru-view-base';
import { TruDataContext } from '../../services/tru-data-context';
import { ITruToolbarDropdownOption } from '../toolbar/classes/tru-toolbar-dropdown-option';
import { TruTextManager } from '../../services/tru-text-manager';
import { TruWindowEventHandler } from '../desktop/services/tru-window-event-handler';
import { TruModelTableLookup } from '../../services/tru-model-table-lookup';
import { TruUiNotification } from '../../services/tru-ui-notification';
import { TruModelPropertyLookup } from '../../services/tru-model-property-lookup';
import { TruModelTypeLookup } from '../../services/tru-model-type-lookup';
import { TruModelNavigationPropertiesLookup } from '../../services/tru-model-navigation-properties-lookup';
import * as i0 from "@angular/core";
export declare class TruCloneView extends TruViewBase {
    protected textManager: TruTextManager;
    protected windowEventHandler: TruWindowEventHandler;
    private dataContext;
    private modelTableLookup;
    private modelPropertyLookup;
    private modelTypeLookup;
    private modelNavigationPropertiesLookup;
    private uiNotification;
    loading: boolean;
    loadingMessage: string;
    numberOfCopies: Array<ITruToolbarDropdownOption>;
    selectedNumberOfCopies: ITruToolbarDropdownOption;
    contextFilters: null;
    rootNode: Node | null;
    ignorePropertyList: string[];
    dataTree: never[];
    flatList: Array<Node>;
    childFlatList: Array<Node>;
    processedCount: number;
    doneProcessing: boolean;
    displayTree: (Node | null)[];
    parentDataContext: TruDataContext;
    constructor(textManager: TruTextManager, windowEventHandler: TruWindowEventHandler, dataContext: TruDataContext, modelTableLookup: TruModelTableLookup, modelPropertyLookup: TruModelPropertyLookup, modelTypeLookup: TruModelTypeLookup, modelNavigationPropertiesLookup: TruModelNavigationPropertiesLookup, uiNotification: TruUiNotification);
    private getNumberOfCopies;
    private propertyIsAllowed;
    private getPrototypeProperties;
    private getChildPropertiesForCurrentEntity;
    private getTypeFromEntityTypeName;
    private buildCloneTree;
    private asyncForEachRecordId;
    private fetchRecordId;
    private traverse;
    private getDataForCloning;
    onClone: () => void;
    onDone: () => void;
    onRendered: () => void;
    onCancel: () => void;
    onExpandClicked: () => void;
    onCollapseClicked: () => void;
    onNumberOfCopiesChanged: (event: any) => void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruCloneView, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TruCloneView, "tru-clone-view", never, {}, {}, never, never, true, never>;
}
declare class Node {
    ref: number | null;
    tableName: string;
    displayName: string;
    checked: boolean;
    child: any;
    childNodes: any;
    showEntities: boolean;
    pathFromRoot: string | null;
    parentToChildRefName: string | null;
    nodes: Node[];
    root: any;
    parent: any;
    entity: any;
    constructor(ref: number | null, tableName: string, displayName: string, child: any, checked: boolean, childEntities: any, pathFromRoot: string | null, parentToChildRefName: string | null, root: boolean, parent: any, entity: any);
    onGroupDisplay: () => void;
    onCheckedChanged: () => void;
}
export {};
