import { AfterViewInit, ApplicationRef, ChangeDetectorRef, ElementRef, OnChanges, OnInit, SimpleChanges, TemplateRef, ViewContainerRef } from '@angular/core';
import type { ColDef } from "ag-grid-community";
import { TruSearchViewEventHandler } from '../../base-views/search/services/tru-search-view-event-handler';
import { TruAppEnvironment } from '../../services/tru-app-environment';
import { TruComponentLookup } from '../../services/tru-component-lookup';
import { TruConnectionHub } from '../../services/tru-connection-hub';
import { TruDataContext } from '../../services/tru-data-context';
import { TruSearchResultViewManager } from '../../services/tru-search-result-view-manager';
import { TruUiNotification } from '../../services/tru-ui-notification';
import { TruUtil } from '../../services/tru-util';
import { TruWindowEventHandler } from '../desktop/services/tru-window-event-handler';
import { TruTabGroupEventNotifier } from '../layout/tab/services/tru-tab-group-event-notifier';
import { ITruToolbarDropdownOption } from '../toolbar/classes/tru-toolbar-dropdown-option';
import { ITruDataGridConfig } from './classes/tru-data-grid-config';
import { TruDataGridTypes } from './enums/tru-data-grid-types';
import * as i0 from "@angular/core";
export declare class TruDataGrid implements OnInit, OnChanges, AfterViewInit {
    private dataContext;
    private componentLookup;
    private searchResultViewManager;
    private appEnvironment;
    private searchViewEventHandler;
    private uiNotification;
    private connectionHub;
    private windowEventHandler;
    private util;
    private app;
    private cdr;
    tabGroupEventNotifier: TruTabGroupEventNotifier;
    dataGridContainer: ElementRef;
    customToolbarContainer: ViewContainerRef;
    config: ITruDataGridConfig;
    entity: any;
    name: any;
    TruDataGridTypes: typeof TruDataGridTypes;
    label: string;
    columnDefs: any;
    rowData: any;
    viewChoices: Array<any>;
    selectedViewChoice: any;
    unassociatedChoices: Array<any>;
    selectedUnassociatedChoice: any;
    viewMenuItems: any;
    customToolbarComponents: any;
    selectedViewMenuItem: any | null;
    gridType: TruDataGridTypes;
    unsavedEntities: Array<any>;
    loadedEntities: Array<any>;
    latestSetupQuery: any;
    firstSearchRan: boolean;
    rowCount: string;
    selectedRowCount: string;
    gridOptions: any;
    parentToolbarTemplate: TemplateRef<any> | null;
    private api;
    private subs;
    private isActive;
    private rowSelectedOnMousedown;
    private rowFocuedOnMousedown;
    private copiedRowData;
    constructor(dataContext: TruDataContext, componentLookup: TruComponentLookup, searchResultViewManager: TruSearchResultViewManager, appEnvironment: TruAppEnvironment, searchViewEventHandler: TruSearchViewEventHandler, uiNotification: TruUiNotification, connectionHub: TruConnectionHub, windowEventHandler: TruWindowEventHandler, util: TruUtil, app: ApplicationRef, cdr: ChangeDetectorRef, tabGroupEventNotifier: TruTabGroupEventNotifier);
    private enhanceRowDataForEntity;
    private setNoRowsTemplate;
    private subscribeTo;
    private getRefs;
    private getRowData;
    private loadGridData;
    private loadManyToManyGridData;
    private exportData;
    private onSuppressKeyboardEvent;
    private addEntity;
    private getMergeData;
    private validationDialog;
    private addValidationDialog;
    private waitForGridApi;
    private runSearch;
    private getPropertyPathParts;
    private renderCustomToolbarComponents;
    defaultColDef: ColDef;
    onRowDataChanged: (data: any) => void;
    onCellMouseDown: (cellData: any) => void;
    onCellClicked: (cellData: any) => void;
    onCellDoubleClicked: (gridConfig: any) => void;
    onCellKeyDown: (params: any) => void;
    onCellMouseOver(e: any): void;
    onCellMouseOut(e: any): void;
    onRightClick(event: MouseEvent): void;
    onSearch: (setupQuery: any) => void;
    onUnassociatedChoiceChanged: (option: Array<ITruToolbarDropdownOption> | null) => void;
    onSelectedReportChanged: (event: any) => void;
    canAdd: () => boolean;
    onAdd: () => void;
    onDelete: () => void;
    onKeep: () => void;
    onRemove: () => void;
    onExport: () => void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruDataGrid, [null, null, null, null, null, null, null, null, null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TruDataGrid, "tru-data-grid", never, { "config": { "alias": "config"; "required": false; }; "entity": { "alias": "entity"; "required": false; }; "name": { "alias": "name"; "required": false; }; }, {}, never, never, true, never>;
}
