import { TruEntityBase } from "../../../base-classes/tru-entity-base";
import { TruContextFilters } from "../../../services/tru-context-filters";
import { TruDesktopTitle } from "../classes/tru-desktop-title";
import { TruDesktopEventHandler } from "./tru-desktop-event-handler";
import { TruWindowEventArgs } from './tru-window-event-args';
import { TruDataContext } from "../../../services/tru-data-context";
import * as i0 from "@angular/core";
export declare class TruDesktopManager {
    private contextFilters;
    private desktopEventHandler;
    constructor(contextFilters: TruContextFilters, desktopEventHandler: TruDesktopEventHandler);
    getWindowEvent: (tableName: string, tablePluralName: string, tablePluralLabel: string, isModal: boolean, componentName: string, entities?: Array<TruEntityBase>, entityIndex?: number, openAsDetaiView?: boolean, showNavigation?: boolean, parentDataContext?: TruDataContext | null) => TruWindowEventArgs;
    /**
     * Opens a window for a directive.
     * @param {string} directiveName - name of the view directive.
     * @param {object} data - values to pass to the view.
     * @param {optional bool} showIfExists - if true and a view already exists for the
     * directive, then shows its window instead of creating a new one.
     */
    addWindow: (tableName: string, tablePluralName: string, tablePluralLabel: string, componentName: string, entities?: Array<TruEntityBase>, openAsDetaiView?: boolean, showNavigation?: boolean, showIfExists?: boolean) => void;
    addModalWindow: (tableName: string, tablePluralName: string, tablePluralLabel: string, componentName: string, entities: Array<TruEntityBase> | undefined, entityIndex: number | undefined, parentDataContext: TruDataContext, openAsDetaiView?: boolean, showNavigation?: boolean, showIfExists?: boolean) => TruWindowEventArgs;
    addWindowForQueryResult: (tableName: string, tablePluralName: string, tablePluralLabel: string, componentName: string, entities?: Array<TruEntityBase>, openAsDetaiView?: boolean, showNavigation?: boolean, showIfExists?: boolean) => void;
    addCustomWindow: (componentName: string, data?: object | null) => void;
    windowTitlesByBaseText: any;
    /**
     * Returns a unique string for the base name of a window.  At first, returns the input.
     * For second call with same base name, returns the name plus ' - 2' and so on.  When
     * all of the titles for the base name are released, then the next title will have no
     * suffix.
     * @param {string} text - base name of a window.
     * @returns {object} - text: the unique text and release(): releases the name for
     *  future windows.
     */
    getUniqueTitle: (text: string) => TruDesktopTitle;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruDesktopManager, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruDesktopManager>;
}
