import { ElementRef, OnInit, QueryList } from '@angular/core';
import { TruDesktopWindow } from '../window/tru-desktop-window';
import * as i0 from "@angular/core";
export declare class TruDesktopViewport implements OnInit {
    private elementRef;
    windows: any;
    desktopCtrl: any;
    windowComponents: QueryList<TruDesktopWindow>;
    options: any;
    constructor(elementRef: ElementRef);
    getViewportDimensions: () => any;
    mouseMove: (event: any) => void;
    mouseUp: (event: any) => void;
    dimensions: any;
    showFillOutline: boolean;
    showLeftOutline: boolean;
    showRightOutline: boolean;
    displayViewportDimensions: boolean;
    logoUrl: undefined;
    viewportMouseDown: (event: any) => void;
    /**
     * @tru.doc $watch function
     * @name truDesktopViewportComponent.visibilityWatch
     * @module tru.desktop.viewport
     * @function
     *
     * @description
     * Monitors for visibility changes. This method is responsible for updating the viewport
     * dimensions in situations where the viewport is initially hidden.
     *
     */
    /**
     * @tru.doc window.resize
     * @name truDesktopViewportComponent.resize
     * @module tru.desktop.viewport
     * @function
     *
     * @description
     * This method is responsible for updating the viewport dimensions when the
     * browser window has been re-sized.
     *
     */
    onResize(event: any): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruDesktopViewport, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TruDesktopViewport, "tru-desktop-viewport", never, { "windows": { "alias": "windows"; "required": false; }; "desktopCtrl": { "alias": "desktopCtrl"; "required": false; }; }, {}, never, never, true, never>;
}
