import { InjectionToken } from "@angular/core";
import { Observable } from "rxjs";
import { TruUser } from "../../../services/tru-user";
export interface TruAuthConfig {
    baseUrl: string;
    authUrl: string;
    auth: "session" | "token";
}
export declare const TRU_AUTH_CONFIG: TruAuthConfig;
export interface TruAuthStrategy<T> {
    doLoginUser(data: T): void;
    doLogoutUser(): void;
    isLoggedIn(): boolean;
    createUser(user: TruUser): Observable<any>;
}
export declare const TRU_AUTH_STRATEGY: InjectionToken<TruAuthStrategy<any>>;
