import { HttpClient } from "@angular/common/http";
import { Router } from "@angular/router";
import { Observable } from "rxjs";
import { TruAuthLoginRequest } from "../classes/tru-auth-login-request";
import { TruAuthCache } from "./tru-auth-cache";
import { TruAuthStrategy } from "../classes/tru-auth-config";
import { TruUser } from "../../../services/tru-user";
import { TruAppEnvironment } from "../../../services/tru-app-environment";
import * as i0 from "@angular/core";
export declare class TruAuth {
    private router;
    private http;
    private cache;
    private user;
    private appEnvironment;
    private auth;
    private loggedIn;
    private baseUrl;
    constructor(router: Router, http: HttpClient, cache: TruAuthCache, user: TruUser, appEnvironment: TruAppEnvironment, auth: TruAuthStrategy<any>);
    login(loginRequest: TruAuthLoginRequest): Observable<any>;
    setUser(): void;
    logout(): void;
    userClaims(): Observable<any>;
    get isLoggedIn(): Observable<boolean>;
    doLogoutAndRedirectToLogin(): void;
    private doLogoutUser;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruAuth, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruAuth>;
}
