import { TruGlobalDataContext } from './tru-global-data-context';
import { TruUser } from './tru-user';
import { TruDataContext } from './tru-data-context';
import { TruModelTypeLookup } from './tru-model-type-lookup';
import { TruTextManager } from './tru-text-manager';
import { TruDesktopManager } from '../components/desktop/services/tru-desktop-manager';
import { TruUiNotification } from './tru-ui-notification';
import { TruWindowEventHandler } from '../components/desktop/services/tru-window-event-handler';
import * as i0 from "@angular/core";
export declare class TruActionInvoke {
    private dataContext;
    private textManager;
    private desktopManager;
    private windowEventHandler;
    private uiNotification;
    private modelTypeLookup;
    private globalDataContext;
    private user;
    constructor(dataContext: TruDataContext, textManager: TruTextManager, desktopManager: TruDesktopManager, windowEventHandler: TruWindowEventHandler, uiNotification: TruUiNotification, modelTypeLookup: TruModelTypeLookup, globalDataContext: TruGlobalDataContext, user: TruUser);
    /**
    * Creates an array of menu item config objects.
    * @param {object[]} menuItemConfigs - Menu item config configs(!)
    * @returns {object[]} - Configs.
    */
    createMenuConfigs: (menuItemConfigs: any) => any[];
    /**
     * Post to a URL that results in a file download.
     * @param {string} url
     * @param {string} actionRefs - Comma separated list of record refs.
     */
    executeHttpPostActionForDownload: (url: any, actionRefs: any) => void;
    /**
     * Execute an action that downloads a file.
     * @param {string} actionName
     * @param {string} actionRefs - Comma separated list of record refs.
     */
    executeActionForDownload: (actionName: any, actionRefs: any) => void;
    /**
     * Execute an action and show the resulting message.
     * @param {string} actionName - Name of an action.
     * @param {string} actionRefs - Comma separated list of record refs.
     */
    executeActionForMessage: (actionName: any, actionRefs: string) => void;
    /**
     * Queue the execution of an action.
     * @param {string} actionName - Name of an action.
     * @param {string} actionRefs - Comma separated list of record refs.
     * @param {string} actionLabel - Display name of the action.
     */
    queueAction: (actionName: string, actionRefs: string, actionLabel: string) => void;
    /**
     * Open a new window with a query function to an action that accepts a list of
     * record refs.
     * @param {string} actionName - Name of an action.
     * @param {string} actionRefs - Comma separated list of record refs.
     * @param {string} componentName - Name of the directive for the window view.
     * @param {object} data - Passed to view.
     */
    openWindowForQueryResultFromAction: (actionName: string, actionRefs: string, componentName: string, data: any) => void;
    /**
     * Open a new view with a URL and a list of record refs.
     * @param {string} url
     * @param {string} actionRefs - Comma separated list of record refs.
     * @param {string} actionLabel - Action label.
     * @param {string} windowCtrl - window manager.
     */
    openViewForReportFromUrl: (url: string, actionRefs: string, actionLabel: string, windowCtrl: string) => void;
    processCustomReport: (reportRef: string, actionRefs: string, mimeRef: string) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruActionInvoke, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruActionInvoke>;
}
