import { Entity } from "breeze-client";
import { Observable } from "rxjs";
import { TruDataContext } from "./tru-data-context";
import * as i0 from "@angular/core";
export interface ActionEventCompleted {
    successful: boolean;
    entities?: Array<Entity>;
}
export declare class TruAppEnvironment {
    private _appName;
    private _appDescription;
    private _appUri;
    private _enablePasswordStrength;
    private _backgroundImageUri;
    private _environmentWarning;
    private _loginFormTitle;
    private _authType;
    private _maxRecordCount;
    private _isSaving;
    private _saveComplete;
    private _revertComplete;
    private _deleteComplete;
    private _globalDataContext;
    readonly msgModifierKeyLabel: string;
    readonly msgConfirmExitWithChangesPending: string;
    readonly msgDeleteSuccessful: string;
    readonly msgSaveSuccessful: string;
    readonly msgSettingsUpdatedSuccessful: string;
    readonly msgNoChangesToSave: string;
    readonly msgSaveInProgress: string;
    readonly msgInvalidData: string;
    readonly msgDirtyPreventsReadOnly: string;
    readonly msgDirtyPreventsNavigate: string;
    readonly msgDirtyPreventsClose: string;
    readonly msgDirtyPreventsDeleteExistingRecord: string;
    readonly msgNoDeleteAccess: string;
    readonly msgCannotDeleteNewAndExistingRecords: string;
    readonly msgDeleteReferencingRecordsFirst: string;
    readonly msgNoRecordsSelected: string;
    onSavingChanged$: Observable<boolean>;
    onSaveComplete$: Observable<ActionEventCompleted | null>;
    onRevertComplete$: Observable<ActionEventCompleted | null>;
    onDeleteComplete$: Observable<ActionEventCompleted | null>;
    constructor();
    get appName(): string;
    set appName(name: string);
    get appDescription(): string;
    set appDescription(description: string);
    get enablePasswordStrength(): boolean;
    set enablePasswordStrength(enable: boolean);
    get backgroundImageUri(): string;
    set backgroundImageUri(uri: string);
    get environmentWarning(): string;
    set environmentWarning(description: string);
    get loginFormTitle(): string;
    set loginFormTitle(description: string);
    get appUri(): string;
    set appUri(uri: string);
    get authType(): 'session' | 'jwt';
    set authType(type: 'session' | 'jwt');
    get isSaving(): boolean;
    set isSaving(isSaving: boolean);
    get maxRecordCount(): number;
    set maxRecordCount(maxRecordCount: number);
    get globalDataContext(): TruDataContext | null;
    set globalDataContext(context: TruDataContext | null);
    get isMac(): boolean;
    saveComplete: (event: ActionEventCompleted) => void;
    revertComplete: (event: ActionEventCompleted) => void;
    deleteComplete: (event: ActionEventCompleted) => void;
    formatDeleteConfirmationMessage: (tableName: string, tablePluralLabel: string, count: number | null) => string;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruAppEnvironment, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruAppEnvironment>;
}
