import { EntityManager, EntityQuery, MetadataStore, Predicate } from 'breeze-client';
import { TruAppEnvironment } from './tru-app-environment';
import { TruBreezeMetadataProvider } from './tru-breeze-metadata-provider';
import * as i0 from "@angular/core";
export declare class TruBreezeContextFactory {
    private breezeMetadataProvider;
    private environment;
    /**
    * Maximum number of records to return from a query.
    * @return {number}
    */
    private servicePath;
    private metadataStore;
    private breezeDataService;
    constructor(breezeMetadataProvider: TruBreezeMetadataProvider, environment: TruAppEnvironment);
    setUpMetadata: (metadata: object) => MetadataStore;
    /**
    * Returns a new data context object.
    * @return {object} - Breeze Manager
    */
    createContext: (tableName?: string | null) => TruBreezeContext;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruBreezeContextFactory, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruBreezeContextFactory>;
}
export declare class TruBreezeContext {
    private manager;
    private _entityManager;
    constructor(manager: EntityManager);
    get createQuery(): (x: any) => EntityQuery;
    get createPredicate(): (...args: any[]) => Predicate;
    get entityManager(): EntityManager;
}
