import { Entity } from "breeze-client";
import { TruEntityBase } from '../base-classes/tru-entity-base';
import { TruUiNotification } from "./tru-ui-notification";
import { TruDataContext } from "./tru-data-context";
import { HttpClient } from "@angular/common/http";
import { Observable } from 'rxjs';
import { TruAppEnvironment } from "./tru-app-environment";
import { TruChoice } from "../classes/tru-choice";
import { TruNameValue } from "../classes/tru-name-value";
import { TruUser } from "./tru-user";
import { TruTextManager } from "./tru-text-manager";
import * as i0 from "@angular/core";
export declare class TruEntityAccessor {
    private httpClient;
    private appEnvironment;
    private uiNotification;
    private textManager;
    private user;
    private _breezeContext;
    private _entityManager;
    private _maxRecordCount;
    private _baseUrl;
    constructor(httpClient: HttpClient, appEnvironment: TruAppEnvironment, uiNotification: TruUiNotification, textManager: TruTextManager, user: TruUser);
    set context(dataContext: TruDataContext);
    private getQueryServiceName;
    private warnIfMaxRecords;
    private formatQueryChoices;
    private formatNameValues;
    add: (entity: typeof TruEntityBase, contextFilters?: any) => Entity;
    search: (entity: typeof TruEntityBase, setupQuery: any | null | undefined, expands: [] | null, global: boolean) => Observable<Entity[]>;
    searchCacheOnly: (entity: typeof TruEntityBase, setupQuery?: any | null, expands?: [] | null) => Observable<Entity[]>;
    searchCacheOnlySynchronously: (entity: typeof TruEntityBase, setupQuery?: any | null, expands?: [] | null) => Array<any>;
    searchByRefCacheOnlySynchronously: (entity: typeof TruEntityBase, ref?: number | null | undefined) => Array<any>;
    searchQueryChoices: (entity: typeof TruEntityBase, setupQuery?: any | null, goToServer?: boolean, ref?: number | null | undefined, allRecords?: boolean, dependantEntty?: typeof TruEntityBase | undefined) => Observable<TruChoice[]>;
    searchNameValuesCacheOnly: (entity: typeof TruEntityBase, setupQuery?: any | null, ref?: number | null | undefined) => Observable<TruNameValue[]>;
    searchByRef: (entity: typeof TruEntityBase, ref: number | null | undefined) => Observable<TruChoice[]>;
    searchByRefPreferedCache: (entity: typeof TruEntityBase, ref: number | null | undefined) => Observable<any>;
    searchByRefCacheOnly: (entity: typeof TruEntityBase, ref: number | null | undefined, includeDeleted?: boolean) => any;
    searchByRefArrayCacheOnly: (entity: typeof TruEntityBase, setupQuery: any | null | undefined, refs: Array<number>, includeDeleted?: boolean) => any[] | null;
    searchByRefWithQuery: (entity: typeof TruEntityBase, setupQuery: any, ref: number) => Observable<Entity[]>;
    searchUserByRefCacheOnly: (ref: number | null | undefined, includeDeleted?: boolean) => any;
    customSearch: (entity: typeof TruEntityBase, query: any) => Observable<any>;
    clone: (data: object) => Observable<Object>;
    export: (entity: typeof TruEntityBase, gridSpec: string, setupQuery: any | null, entityRefs: string | null, options: any) => void;
    downloadFromUrl: (url: string, data: any) => void;
    downloadFromService: (serviceName: string, data: any) => void;
    uploadFromUrl: (url: string, data: FormData) => void;
    /**
    * Request an action.
    * @param {string} actionName - Name of the action.
    * @param {string} entityRefs - Comma separated list of entity pkey values.
    * @returns {promise} on success, passes the results to success handler;
    *      on failure, passes exception to fail handler.
    */
    requestAction: (actionName: string, entityRefs: string) => Observable<any>;
    private saveDownloadedFile;
    private extractFilenameFromContentDisposition;
    /**
      * Imports the data of a set of files.
      *
      * IMPLEMENTATION
      * The input element stores the list of files the user selects. If the user were to
      * use the same input element to select the same file(s) the next time, then the input
      * element would not fire the change event -- resulting in no import.  Therefore, need
      * to clear the file selection.  The implementation of clearing is slightly different
      * for IE vs. Chrome.  In Chrome, clearing the selection (by setting the element value
      * to null) results in clearing the FileList object that was passed to the change handler
      * (this function).  Therefore, need to clear the selection _after_ using the passed
      * FileList object.  For IE, clearing the selection does not clear the FileList passed
      * to the handler, but it does cause the change handler to fire.  To ignore this event,
      * return if the FileList is empty -- which it is since just cleared it.
      */
    import: (files: Array<File>) => void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruEntityAccessor, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruEntityAccessor>;
}
