import * as i0 from "@angular/core";
export declare class TruSort {
    constructor();
    /**
      * @callback differenceCallback
      * @param {*} valueA - any value except for undefined or null
      * @param {*} valueB - any value except for undefined or null
      * @return {number} - <0 for a sorts before b, 0 for a sorts same as b, >0 for a sorts after b.
      */
    /**
      * A generalized comparison algorithm for use with a sort function.  Ensures that null
      * sorts before non-null.  Delegates to difference() for both non-null values.
      * @param {*} valueA - any value except for undefined
      * @param {*} valueB - any value except for undefined
      * @param {differenceCallback} difference - same result meaning as for this function.
      * @return {number} - <0 for a sorts before b, 0 for a sorts same as b, >0 for a sorts after b.
      */
    numCompare: (valueA: any, valueB: any, difference: any) => any;
    compare: (valueA: any, valueB: any, difference: any, inverted?: boolean) => any;
    /**
     * Sort comparison for unnamed, number field control config objects.
     * @param {object} a,b - control config
     * @returns {number}
     */
    numberCompare: (a: any, b: any) => any;
    /**
     * Alphabetical sort comparison for unnamed, string field control config objects.
     * @param {object} a,b - control config
     * @returns {number}
     */
    textCompare: (a: any, b: any) => any;
    dateCompare: (a: any, b: any) => any;
    /**
     * @callback filterCallback
     * @param {object} a,b - Control config
     * @returns {string}
     */
    /**
     * Alphabetical sort comparison for strings.  Both input values are control config
     * objects and passed to a filter function to obtain a value for comparison.
     * @param {object} a,b - control config
     * @param {filterCallback} filter - filter function
     * @returns {number}
     */
    filteredTextCompare: (a: any, b: any, filter: any) => any;
    /**
    * Alphabetical sort comparison for strings.  Both input values are control config
    * objects and passed to a filter function to obtain a value for comparison.
    * @param {object} entity - a breeze $entity
    * @param {array} pathSegments - a list of strings that make up a navigation path
    * @returns {value}
    */
    getValueFromSortPath: (entity: any, pathSegments: any) => any;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruSort, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruSort>;
}
