import { MatDialog } from '@angular/material/dialog';
import { ToastrService } from 'ngx-toastr';
import * as i0 from "@angular/core";
export declare class TruUiNotification {
    private toastr;
    private dialog;
    private _toastr;
    private _dialog;
    constructor(toastr: ToastrService, dialog: MatDialog);
    showMessage: (popup: any, log: (message: string) => void, prefix: string, message: string, detail?: Array<string> | null) => void;
    /**
    * Shows as toast and logs to server an error message and optional detail information.
    * @param {string} message - Displayed as toast.
    * @param {string} [detail] - Logged to console.
    */
    error: (message: string, detail?: Array<string> | null) => void;
    /**
      * Same as error() but for info message.
      */
    info: (message: string, detail?: Array<string> | null) => void;
    /**
     * Same as error() but for success message.
     */
    success: (message: string, detail?: Array<string> | null) => void;
    /**
     * Same as error() but for warning message.
     */
    warning: (message: string, detail?: Array<string> | null) => void;
    log: (message: string) => void;
    showErrorDialog: (title: string, message: string) => void;
    showExportDialog: () => Promise<boolean>;
    confirm: (title: string, message: string, displayCancelButton?: boolean, displayConfirmButton?: boolean, cancelButtonName?: string, confirmButtonName?: string) => Promise<boolean>;
    changePassword: (userRef: number, username: string, admin?: boolean, entity?: any) => Promise<boolean>;
    about: () => Promise<boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruUiNotification, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruUiNotification>;
}
