import { TruAppEnvironment } from './tru-app-environment';
import { TruModelTypeLookup } from './tru-model-type-lookup';
import { TruUser } from './tru-user';
import * as i0 from "@angular/core";
export declare class TruUserPreferenceManager {
    private modelTypeLookup;
    private appEnvironment;
    private user;
    private globalDataContext;
    constructor(modelTypeLookup: TruModelTypeLookup, appEnvironment: TruAppEnvironment, user: TruUser);
    private setupQuery;
    /**
     * Queries for a preference for the current user.  On success, completes
     * promise with the value or undefined if none.
     * @param {string} name - preference name
     * @returns {promise}
     */
    get: (name: string) => any;
    /**
     * Queries for all preferences for the current user.  On success, completes
     * promise with an object loaded with the values indexed by name.
     * @returns {promise}
     */
    getAll: () => Promise<void>;
    /**
     * Saves the value of a preference.  On success, completes promise with no value.
     * @param {string} name - preference name
     * @param {string} value - value text
     * @returns {promise}
     */
    set: (name: string, value: string) => Promise<void>;
    /**
     * Deletes a preference.
     * @param {string} name - preference name
     */
    eliminate: (name: string) => Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<TruUserPreferenceManager, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TruUserPreferenceManager>;
}
